scala.collection

# MapLike

#### trait MapLike[A, +B, +This <: MapLike[A, B, This] with Map[A, B]] extends PartialFunction[A, B] with IterableLike[(A, B), This] with GenMapLike[A, B, This] with Subtractable[A, This] with Parallelizable[(A, B), ParMap[A, B]]

A template trait for maps, which associate keys with values.

Implementation note: This trait provides most of the operations of a `Map` independently of its representation. It is typically inherited by concrete implementations of maps.

To implement a concrete map, you need to provide implementations of the following methods:

          def get(key: A): Option[B]
          def iterator: Iterator[(A, B)]
          def + [B1 >: B](kv: (A, B1)): This
          def -(key: A): This

If you wish that methods like `take`, `drop`, `filter` also return the same kind of map you should also override:

          def empty: This

It is also good idea to override methods `foreach` and `size` for efficiency.

Self Type
  MapLike[A, B, This]
Source
  MapLike.scala
Since

  2.8

Linear Supertypes
Subtractable[A, This], GenMapLike[A, B, This], IterableLike[(A, B), This], GenIterableLike[(A, B), This], TraversableLike[(A, B), This], GenTraversableLike[(A, B), This], Parallelizable[(A, B), ParMap[A, B]], TraversableOnce[(A, B)], GenTraversableOnce[(A, B)], FilterMonadic[(A, B), This], HasNewBuilder[(A, B), This], Equals, PartialFunction[A, B], (A) ⇒ B, AnyRef, Any
Known Subclasses
ConcurrentMap, DefaultMap, DefaultMap, DefaultMapModel, EmptyMap, EmptyMap, HashMap, HashMap, HashMap1, HashTrieMap, ImmutableMapAdaptor, IntMap, JConcurrentMapWrapper, JDictionaryWrapper, JMapWrapper, JMapWrapperLike, JPropertiesWrapper, LinkedHashMap, ListMap, ListMap, LongMap, Map, Map, Map, Map1, Map2, Map3, Map4, MapLike, MapLike, MapProxy, MapProxy, MapProxy, MapProxyLike, MultiMap, Node, ObservableMap, OpenHashMap, PicklerEnv, SortedMap, SortedMap, SortedMapLike, SynchronizedMap, SystemProperties, TreeMap, UnPicklerEnv, WeakHashMap, WithDefault, WithDefault, WithDefault
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. MapLike
2. Subtractable
3. GenMapLike
4. IterableLike
5. GenIterableLike
6. TraversableLike
7. GenTraversableLike
8. Parallelizable
9. TraversableOnce
10. GenTraversableOnce
11. FilterMonadic
12. HasNewBuilder
13. Equals
14. PartialFunction
15. Function1
16. AnyRef
17. Any

Visibility

1. Public
2. All

### Type Members

1. #### class DefaultKeySet extends Set[A]

   The implementation class of the set returned by `keySet`.

2. #### class DefaultValuesIterable extends Iterable[B]

   The implementation class of the iterable returned by `values`.

3. #### type Self = This

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

4. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

### Abstract Value Members

1. #### abstract def +[B1 >: B](kv: (A, B1)): Map[A, B1]

   Adds a key/value pair to this map, returning a new map.

   Adds a key/value pair to this map, returning a new map.

   B1

     the type of the value in the key/value pair.

   kv

     the key/value pair

   returns

     a new map with the new binding added to this map

   Definition Classes
     MapLike → GenMapLike

2. #### abstract def -(key: A): This

   Removes a key from this map, returning a new map.

   Removes a key from this map, returning a new map.

   key

     the key to be removed

   returns

     a new map without a binding for `key`

   Definition Classes
     MapLike → Subtractable → GenMapLike

3. #### abstract def empty: This

   The empty map of the same type as this map

   The empty map of the same type as this map

   returns

     an empty map of type `This`.

4. #### abstract def get(key: A): Option[B]

   Optionally returns the value associated with a key.

   Optionally returns the value associated with a key.

   key

     the key value

   returns

     an option value containing the value associated with `key` in this map, or `None` if none exists.

   Definition Classes
     MapLike → GenMapLike

5. #### abstract def iterator: Iterator[(A, B)]

   Creates a new iterator over all key/value pairs of this map

   Creates a new iterator over all key/value pairs of this map

   returns

     the new iterator

   Definition Classes
     MapLike → IterableLike → GenIterableLike

6. #### abstract def seq: Map[A, B]

   Definition Classes
     GenMapLike → Parallelizable → GenTraversableOnce

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### abstract def +(kvs: (A, B)*): Map[A, B]

   [use case] Adds key/value pairs to this map, returning a new map.

   [use case]

   Adds key/value pairs to this map, returning a new map.

   kvs

     the remaining key/value pairs

   returns

     a new map with the given bindings added to this map

5. #### def +[B1 >: B](kv1: (A, B1), kv2: (A, B1), kvs: (A, B1)*): Map[A, B1]

   Adds key/value pairs to this map, returning a new map.

   Adds key/value pairs to this map, returning a new map.

   This method takes two or more key/value pairs. Another overloaded variant of this method handles the case where a single key/value pair is added.

   B1

     the type of the added values

   kv1

     the first key/value pair

   kv2

     the second key/value pair

   kvs

     the remaining key/value pairs

   returns

     a new map with the given bindings added to this map

6. #### abstract def +(kv: (A, B)): Map[A, B]

   [use case] Adds a key/value pair to this map, returning a new map.

   [use case]

   Adds a key/value pair to this map, returning a new map.

   kv

     the key/value pair

   returns

     a new map with the new binding added to this map

7. #### abstract def ++(xs: Traversable[(A, B)]): Map[A, B]

   [use case] Adds all key/value pairs in a traversable collection to this map, returning a new map.

   [use case]

   Adds all key/value pairs in a traversable collection to this map, returning a new map.

   returns

     a new map with the given bindings added to this map

8. #### def ++[B1 >: B](xs: GenTraversableOnce[(A, B1)]): Map[A, B1]

   Adds all key/value pairs in a traversable collection to this map, returning a new map.

   Adds all key/value pairs in a traversable collection to this map, returning a new map.

   B1

     the type of the added values

   returns

     a new map with the given bindings added to this map

9. #### abstract def ++[B](that: GenTraversableOnce[B]): Map[B]

   [use case] Returns a new map containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new map containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the map is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this map followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

10. #### def ++[B >: (A, B), That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[This, B, That]): That

    Returns a new map containing the elements from the left hand operand followed by the elements from the right hand operand.

    Returns a new map containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the map is the most specific superclass encompassing the element types of the two operands (see example).

    Example:

            scala> val a = LinkedList(1)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

            scala> val b = LinkedList(2)
            b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

            scala> val c = a ++ b
            c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

            scala> val d = LinkedList('a')
            d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

            scala> val e = c ++ d
            e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    that

      the traversable to append.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` which contains all elements of this map followed by all elements of `that`.

    Definition Classes
      TraversableLike → GenTraversableLike

11. #### def ++:[B >: (A, B), That](that: Traversable[B])(implicit bf: CanBuildFrom[This, B, That]): That

    As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

    As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand. It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one.

    Example:

            scala> val x = List(1)
            x: List[Int] = List(1)

            scala> val y = LinkedList(2)
            y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

            scala> val z = x ++: y
            z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

    This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

    Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    that

      the traversable to append.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new map which contains all elements of this map followed by all elements of `that`.

    Definition Classes
      TraversableLike

12. #### abstract def ++:[B](that: TraversableOnce[B]): Map[B]

    [use case] Concatenates this map with the elements of a traversable collection.

    [use case]

    Concatenates this map with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

    B

      the element type of the returned collection.

    that

      the traversable to append.

    returns

      a new collection of type `That` which contains all elements of this map followed by all elements of `that`.

    Definition Classes
      TraversableLike

13. #### def ++:[B >: (A, B), That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[This, B, That]): That

    Concatenates this map with the elements of a traversable collection.

    Concatenates this map with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

    Example:

            scala> val x = List(1)
            x: List[Int] = List(1)

            scala> val y = LinkedList(2)
            y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

            scala> val z = x ++: y
            z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    that

      the traversable to append.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` which contains all elements of this map followed by all elements of `that`.

    Definition Classes
      TraversableLike

14. #### def -(elem1: A, elem2: A, elems: A*): This

    Creates a new map from this map with some elements removed.

    Creates a new map from this map with some elements removed.

    This method takes two or more elements to be removed. Another overloaded variant of this method handles the case where a single element is removed.

    elem1

      the first element to remove.

    elem2

      the second element to remove.

    elems

      the remaining elements to remove.

    returns

      a new map that contains all elements of the current map except one less occurrence of each of the given elements.

    Definition Classes
      Subtractable

15. #### abstract def -(key: A): Map[A, B]

    [use case] Removes a key from this map, returning a new map.

    [use case]

    Removes a key from this map, returning a new map.

    key

      the key to be removed

    returns

      a new map without a binding for `key`

    Definition Classes
      MapLike → Subtractable → GenMapLike

16. #### def --(xs: GenTraversableOnce[A]): This

    Creates a new map from this map by removing all elements of another collection.

    Creates a new map from this map by removing all elements of another collection.

    returns

      a new map that contains all elements of the current map except one less occurrence of each of the elements of `elems`.

    Definition Classes
      Subtractable

17. #### def /:[B](z: B)(op: (B, (A, B)) ⇒ B): B

    Applies a binary operator to a start value and all elements of this map, going left to right.

    Applies a binary operator to a start value and all elements of this map, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (5 /: a)(_+_)
             b: Int = 15

             scala> val c = (5 /: a)((x,y) => x + y)
             c: Int = 15

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this map, going left to right with the start value `z` on the left:

                      op(...op(op(z, x1), x2), ..., xn)

      where `x1, ..., xn` are the elements of this map.

    Definition Classes
      TraversableOnce → GenTraversableOnce

18. #### def /:\[A1 >: (A, B)](z: A1)(op: (A1, A1) ⇒ A1): A1

    A syntactic sugar for out of order folding.

    A syntactic sugar for out of order folding. See `fold`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a /:\ 5)(_+_)
             b: Int = 15

    Definition Classes
      GenTraversableOnce

19. #### def :\[B](z: B)(op: ((A, B), B) ⇒ B): B

    Applies a binary operator to all elements of this map and a start value, going right to left.

    Applies a binary operator to all elements of this map and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this map, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this map.

    Definition Classes
      TraversableOnce → GenTraversableOnce

20. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

21. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

22. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all bindings of this map to a string builder using start, end, and separator strings.

    Appends all bindings of this map to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations of all bindings of this map in the form of `key -> value` are separated by the string `sep`.

    b

      the builder to which strings are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      MapLike → TraversableOnce

23. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this map to a string builder.

    Appends all elements of this map to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this map without any separator string.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> val h = a.addString(b)
             b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

24. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this map to a string builder using a separator string.

    Appends all elements of this map to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this map, separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, ", ")
             res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

25. #### def aggregate[B](z: B)(seqop: (B, (A, B)) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

26. #### def andThen[C](k: (B) ⇒ C): PartialFunction[A, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the same domain as this partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1

27. #### def apply(key: A): B

    Retrieves the value which is associated with the given key.

    Retrieves the value which is associated with the given key. This method invokes the `default` method of the map if there is no mapping from the given key to a value. Unless overridden, the `default` method throws a `NoSuchElementException`.

    key

      the key

    returns

      the value associated with the given key, or the result of the map's `default` method, if none exists.

    Definition Classes
      MapLike → GenMapLike → Function1

28. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

29. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this map should be compared

    returns

      `true`, if this map can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

30. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

31. #### abstract def collect[B](pf: PartialFunction[(A, B), B]): Map[B]

    [use case] Builds a new collection by applying a partial function to all elements of this map on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this map on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the map.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

32. #### def collect[B, That](pf: PartialFunction[(A, B), B])(implicit bf: CanBuildFrom[This, B, That]): That

    Builds a new collection by applying a partial function to all elements of this map on which the function is defined.

    Builds a new collection by applying a partial function to all elements of this map on which the function is defined.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    pf

      the partial function which filters and maps the map.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

33. #### def collectFirst[B](pf: PartialFunction[(A, B), B]): Option[B]

    Finds the first element of the map for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the map for which the given partial function is defined, and applies the partial function to it.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

34. #### def compose[A](g: (A) ⇒ A): (A) ⇒ B

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1

35. #### def contains(key: A): Boolean

    Tests whether this map contains a binding for a key.

    Tests whether this map contains a binding for a key.

    key

      the key

    returns

      `true` if there is a binding for `key` in this map, `false` otherwise.

36. #### abstract def copyToArray(xs: Array[(A, B)], start: Int, len: Int): Unit

    [use case] Copies elements of this map to an array.

    [use case]

    Copies elements of this map to an array. Fills the given array `xs` with at most `len` elements of this map, starting at position `start`. Copying will stop once either the end of the current map is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      TraversableLike

37. #### def copyToArray[B >: (A, B)](xs: Array[B], start: Int, len: Int): Unit

    Copies elements of this map to an array.

    Copies elements of this map to an array. Fills the given array `xs` with at most `len` elements of this map, starting at position `start`. Copying will stop once either the end of the current map is reached, or the end of the array is reached, or `len` elements have been copied.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

38. #### abstract def copyToArray(xs: Array[(A, B)]): Unit

    [use case] Copies values of this map to an array.

    [use case]

    Copies values of this map to an array. Fills the given array `xs` with values of this map. Copying will stop once either the end of the current map is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

39. #### def copyToArray[B >: (A, B)](xs: Array[B]): Unit

    Copies values of this map to an array.

    Copies values of this map to an array. Fills the given array `xs` with values of this map. Copying will stop once either the end of the current map is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce

40. #### abstract def copyToArray(xs: Array[(A, B)], start: Int): Unit

    [use case] Copies values of this map to an array.

    [use case]

    Copies values of this map to an array. Fills the given array `xs` with values of this map, beginning at index `start`. Copying will stop once either the end of the current map is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

41. #### def copyToArray[B >: (A, B)](xs: Array[B], start: Int): Unit

    Copies values of this map to an array.

    Copies values of this map to an array. Fills the given array `xs` with values of this map, beginning at index `start`. Copying will stop once either the end of the current map is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce

42. #### def copyToBuffer[B >: (A, B)](dest: Buffer[B]): Unit

    Copies all elements of this map to a buffer.

    Copies all elements of this map to a buffer.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

43. #### def count(p: ((A, B)) ⇒ Boolean): Int

    Counts the number of elements in the map which satisfy a predicate.

    Counts the number of elements in the map which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

44. #### def default(key: A): B

    Defines the default value computation for the map, returned when a key is not found The method implemented here throws an exception, but it might be overridden in subclasses.

    Defines the default value computation for the map, returned when a key is not found The method implemented here throws an exception, but it might be overridden in subclasses.

    key

      the given key value for which a binding is missing.

    Definition Classes
      MapLike → GenMapLike
    Exceptions thrown
      `NoSuchElementException`

45. #### def drop(n: Int): This

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this map.

    returns

      a map consisting of all elements of this map except the first `n` ones, or else the empty map, if this map has less than `n` elements.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike

46. #### def dropRight(n: Int): This

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      The number of elements to take

    returns

      a map consisting of all elements of this map except the last `n` ones, or else the empty map, if this map has less than `n` elements.

    Definition Classes
      IterableLike

47. #### def dropWhile(p: ((A, B)) ⇒ Boolean): This

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      The predicate used to test elements.

    returns

      the longest suffix of this map whose first element does not satisfy the predicate `p`.

    Definition Classes
      TraversableLike → GenTraversableLike

48. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

49. #### def equals(that: Any): Boolean

    Compares two maps structurally; i.

    Compares two maps structurally; i.e. checks if all mappings contained in this map are also contained in the other map, and vice versa.

    that

      the other map

    returns

      `true` if both maps contain exactly the same mappings, `false` otherwise.

    Definition Classes
      GenMapLike → Equals → AnyRef → Any

50. #### def exists(p: ((A, B)) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this map.

    Tests whether a predicate holds for some of the elements of this map.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this map, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

51. #### def filter(p: ((A, B)) ⇒ Boolean): This

    Selects all elements of this map which satisfy a predicate.

    Selects all elements of this map which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new map consisting of all elements of this map that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

52. #### def filterKeys(p: (A) ⇒ Boolean): Map[A, B]

    Filters this map by retaining only keys satisfying a predicate.

    Filters this map by retaining only keys satisfying a predicate.

    p

      the predicate used to test keys

    returns

      an immutable map consisting only of those key value pairs of this map where the key satisfies the predicate `p`. The resulting map wraps the original map without copying any elements.

53. #### def filterNot(p: ((A, B)) ⇒ Boolean): This

    Returns a new map with all key/value pairs for which the predicate `p` returns `true`.

    Returns a new map with all key/value pairs for which the predicate `p` returns `true`.

    Note: This method works by successively removing elements fro which the predicate is false from this set. If removal is slow, or you expect that most elements of the set will be removed, you might consider using `filter` with a negated predicate instead.

    p

      A predicate over key-value pairs

    returns

      A new map containing elements not satisfying the predicate.

    Definition Classes
      MapLike → TraversableLike → GenTraversableLike

54. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

55. #### def find(p: ((A, B)) ⇒ Boolean): Option[(A, B)]

    Finds the first element of the map satisfying a predicate, if any.

    Finds the first element of the map satisfying a predicate, if any.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the map that satisfies `p`, or `None` if none exists.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

56. #### abstract def flatMap[B](f: ((A, B)) ⇒ GenTraversableOnce[B]): Map[B]

    [use case] Builds a new collection by applying a function to all elements of this map and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this map and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this map and concatenating the results.

    Definition Classes
      GenTraversableLike

57. #### def flatMap[B, That](f: ((A, B)) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[This, B, That]): That

    Builds a new collection by applying a function to all elements of this map and using the elements of the resulting collections.

    Builds a new collection by applying a function to all elements of this map and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of map. This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this map and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

58. #### def fold[A1 >: (A, B)](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this map using the specified associative binary operator.

    Folds the elements of this map using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

59. #### def foldLeft[B](z: B)(op: (B, (A, B)) ⇒ B): B

    Applies a binary operator to a start value and all elements of this map, going left to right.

    Applies a binary operator to a start value and all elements of this map, going left to right.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this map, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this map.

    Definition Classes
      TraversableOnce → GenTraversableOnce

60. #### def foldRight[B](z: B)(op: ((A, B), B) ⇒ B): B

    Applies a binary operator to all elements of this map and a start value, going right to left.

    Applies a binary operator to all elements of this map and a start value, going right to left.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this map, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this map.

    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce

61. #### def forall(p: ((A, B)) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this map.

    Tests whether a predicate holds for all elements of this map.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this map, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

62. #### abstract def foreach(f: ((A, B)) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this map.

    [use case]

    Applies a function `f` to all elements of this map.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike

63. #### def foreach[U](f: ((A, B)) ⇒ U): Unit

    Applies a function `f` to all elements of this map.

    Applies a function `f` to all elements of this map.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    U

      the type parameter describing the result of function `f`. This result will always be ignored. Typically `U` is `Unit`, but this is not necessary.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic

64. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

65. #### abstract def getOrElse(key: A, default: ⇒ B): B

    [use case] Returns the value associated with a key, or a default value if the key is not contained in the map.

    [use case]

    Returns the value associated with a key, or a default value if the key is not contained in the map.

    key

      the key.

    default

      a computation that yields a default value in case no binding for `key` is found in the map.

    returns

      the value associated with `key` if it exists, otherwise the result of the `default` computation.

66. #### def getOrElse[B1 >: B](key: A, default: ⇒ B1): B1

    Returns the value associated with a key, or a default value if the key is not contained in the map.

    Returns the value associated with a key, or a default value if the key is not contained in the map.

    B1

      the result type of the default computation.

    key

      the key.

    default

      a computation that yields a default value in case no binding for `key` is found in the map.

    returns

      the value associated with `key` if it exists, otherwise the result of the `default` computation.

67. #### def groupBy[K](f: ((A, B)) ⇒ K): Map[K, This]

    Partitions this map into a map of maps according to some discriminator function.

    Partitions this map into a map of maps according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new map.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to maps such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a map of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

68. #### def grouped(size: Int): Iterator[This]

    Partitions elements in fixed size maps.

    Partitions elements in fixed size maps.

    size

      the number of elements per group

    returns

      An iterator producing maps of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      Iterator#grouped

69. #### def hasDefiniteSize: Boolean

    Tests whether this map is known to have a finite size.

    Tests whether this map is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

70. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      GenMapLike → AnyRef → Any

71. #### def head: (A, B)

    Selects the first element of this map.

    Selects the first element of this map.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this map.

    Definition Classes
      IterableLike → GenIterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the map is empty.

72. #### def headOption: Option[(A, B)]

    Optionally selects the first element.

    Optionally selects the first element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this map if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

73. #### def init: This

    Selects all elements except the last.

    Selects all elements except the last.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a map consisting of all elements of this map except the last one.

    Definition Classes
      TraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the map is empty.

74. #### def inits: Iterator[This]

    Iterates over the inits of this map.

    Iterates over the inits of this map. The first value will be this map and the final one will be an empty map, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this map

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

75. #### def isDefinedAt(key: A): Boolean

    Tests whether this map contains a binding for a key.

    Tests whether this map contains a binding for a key. This method, which implements an abstract method of trait `PartialFunction`, is equivalent to `contains`.

    key

      the key

    returns

      `true` if there is a binding for `key` in this map, `false` otherwise.

    Definition Classes
      MapLike → PartialFunction

76. #### def isEmpty: Boolean

    Tests whether the map is empty.

    Tests whether the map is empty.

    returns

      `true` if the map does not contain any key/value binding, `false` otherwise.

    Definition Classes
      MapLike → IterableLike → GenIterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

77. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

78. #### final def isTraversableAgain: Boolean

    Tests whether this map can be repeatedly traversed.

    Tests whether this map can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

79. #### def keySet: Set[A]

    Collects all keys of this map in a set.

    Collects all keys of this map in a set.

    returns

      a set containing all keys of this map.

80. #### def keys: Iterable[A]

    Collects all keys of this map in an iterable collection.

    Collects all keys of this map in an iterable collection.

    returns

      the keys of this map as an iterable.

    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `keys` returns `Iterable[A]` rather than `Iterator[A]`.

81. #### def keysIterator: Iterator[A]

    Creates an iterator for all keys.

    Creates an iterator for all keys.

    returns

      an iterator over all keys.

82. #### def last: (A, B)

    Selects the last element.

    Selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      The last element of this map.

    Definition Classes
      TraversableLike
    Exceptions thrown
      NoSuchElementException

      If the map is empty.

83. #### def lastOption: Option[(A, B)]

    Optionally selects the last element.

    Optionally selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the last element of this map$ if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

84. #### def lift: (A) ⇒ Option[B]

    Turns this partial function into an plain function returning an `Option` result.

    Turns this partial function into an plain function returning an `Option` result.

    returns

      a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

    Definition Classes
      PartialFunction
    See also

      Function.unlift

85. #### abstract def map[B](f: ((A, B)) ⇒ B): Map[B]

    [use case] Builds a new collection by applying a function to all elements of this map.

    [use case]

    Builds a new collection by applying a function to all elements of this map.

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this map and collecting the results.

    Definition Classes
      GenTraversableLike

86. #### def map[B, That](f: ((A, B)) ⇒ B)(implicit bf: CanBuildFrom[This, B, That]): That

    Builds a new collection by applying a function to all elements of this map.

    Builds a new collection by applying a function to all elements of this map.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this map and collecting the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

87. #### def mapValues[C](f: (B) ⇒ C): Map[A, C]

    Transforms this map by applying a function to every retrieved value.

    Transforms this map by applying a function to every retrieved value.

    f

      the function used to transform values of this map.

    returns

      a map view which maps every key of this map to `f(this(key))`. The resulting map wraps the original map without copying any elements.

88. #### abstract def max: (A, B)

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this map with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

89. #### def max[B >: (A, B)](implicit cmp: Ordering[B]): (A, B)

    Finds the largest element.

    Finds the largest element.

    B

      The type over which the ordering is defined.

    cmp

      An ordering to be used for comparing elements.

    returns

      the largest element of this map with respect to the ordering `cmp`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

90. #### def maxBy[B](f: ((A, B)) ⇒ B)(implicit cmp: Ordering[B]): (A, B)

    Definition Classes
      TraversableOnce → GenTraversableOnce

91. #### abstract def min: (A, B)

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this map with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

92. #### def min[B >: (A, B)](implicit cmp: Ordering[B]): (A, B)

    Finds the smallest element.

    Finds the smallest element.

    B

      The type over which the ordering is defined.

    cmp

      An ordering to be used for comparing elements.

    returns

      the smallest element of this map with respect to the ordering `cmp`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

93. #### def minBy[B](f: ((A, B)) ⇒ B)(implicit cmp: Ordering[B]): (A, B)

    Definition Classes
      TraversableOnce → GenTraversableOnce

94. #### def mkString: String

    Displays all elements of this map in a string.

    Displays all elements of this map in a string.

    returns

      a string representation of this map. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this map follow each other without any separator string.

    Definition Classes
      TraversableOnce → GenTraversableOnce

95. #### def mkString(sep: String): String

    Displays all elements of this map in a string using a separator string.

    Displays all elements of this map in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this map. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this map are separated by the string `sep`.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

96. #### def mkString(start: String, sep: String, end: String): String

    Displays all elements of this map in a string using start, end, and separator strings.

    Displays all elements of this map in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this map. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this map are separated by the string `sep`.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

97. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

98. #### def newBuilder: Builder[(A, B), This]

    A common implementation of `newBuilder` for all maps in terms of `empty`.

    A common implementation of `newBuilder` for all maps in terms of `empty`. Overridden for mutable maps in `mutable.MapLike`.

    Attributes
      protected[this]
    Definition Classes
      MapLike → TraversableLike → HasNewBuilder

99. #### def nonEmpty: Boolean

    Tests whether the map is not empty.

    Tests whether the map is not empty.

    returns

      `true` if the map contains at least one element, `false` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

100. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

101. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

102. #### def orElse[A1 <: A, B1 >: B](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction

103. #### def par: ParMap[A, B]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

104. #### def parCombiner: Combiner[(A, B), ParMap[A, B]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       MapLike → TraversableLike → Parallelizable

105. #### def partition(p: ((A, B)) ⇒ Boolean): (This, This)

     Partitions this map in two maps according to a predicate.

     Partitions this map in two maps according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of maps: the first map consists of all elements that satisfy the predicate `p` and the second map consists of all elements that don't. The relative order of the elements in the resulting maps is the same as in the original map.

     Definition Classes
       TraversableLike → GenTraversableLike

106. #### abstract def product: (A, B)

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements of this map with respect to the `*` operator in `num`.

     Definition Classes
       GenTraversableOnce

107. #### def product[B >: (A, B)](implicit num: Numeric[B]): B

     Multiplies up the elements of this collection.

     Multiplies up the elements of this collection.

     B

       the result type of the `*` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

     returns

       the product of all elements of this map with respect to the `*` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

108. #### def reduce[A1 >: (A, B)](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this map using the specified associative binary operator.

     Reduces the elements of this map using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the map is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this map is empty.

109. #### def reduceLeft[B >: (A, B)](op: (B, (A, B)) ⇒ B): B

     Definition Classes
       TraversableOnce

110. #### def reduceLeftOption[B >: (A, B)](op: (B, (A, B)) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this map, going left to right.

     Optionally applies a binary operator to all elements of this map, going left to right.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this map is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

111. #### def reduceOption[A1 >: (A, B)](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this map, if any, using the specified associative binary operator.

     Reduces the elements of this map, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

112. #### def reduceRight[B >: (A, B)](op: ((A, B), B) ⇒ B): B

     Applies a binary operator to all elements of this map, going right to left.

     Applies a binary operator to all elements of this map, going right to left.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this map, going right to left:

                       op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

       where `x1, ..., xn` are the elements of this map.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this map is empty.

113. #### def reduceRightOption[B >: (A, B)](op: ((A, B), B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this map, going right to left.

     Optionally applies a binary operator to all elements of this map, going right to left.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this map is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

114. #### def repr: This

     The collection of type map underlying this `TraversableLike` object.

     The collection of type map underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

115. #### def reversed: List[(A, B)]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

116. #### abstract def sameElements(that: GenIterable[(A, B)]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this map.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this map.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       GenIterableLike

117. #### def sameElements[B >: (A, B)](that: GenIterable[B]): Boolean

     Checks if the other iterable collection contains the same elements in the same order as this map.

     Checks if the other iterable collection contains the same elements in the same order as this map.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the elements of collection `that`.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IterableLike → GenIterableLike

118. #### def scan[B >: (A, B), That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[This, B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new map containing the prefix scan of the elements in this map

     Definition Classes
       TraversableLike → GenTraversableLike

119. #### def scanLeft[B, That](z: B)(op: (B, (A, B)) ⇒ B)(implicit bf: CanBuildFrom[This, B, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

120. #### def scanRight[B, That](z: B)(op: ((A, B), B) ⇒ B)(implicit bf: CanBuildFrom[This, B, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

121. #### def size: Int

     The size of this map.

     The size of this map.

     returns

       the number of elements in this map.

     Definition Classes
       TraversableOnce → GenTraversableOnce

122. #### def slice(from: Int, until: Int): This

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     from

       the lowest index to include from this map.

     until

       the highest index to EXCLUDE from this map.

     returns

       a map containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this map.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

123. #### def sliding[B >: (A, B)](size: Int, step: Int): Iterator[This]

     Definition Classes
       IterableLike

124. #### def sliding[B >: (A, B)](size: Int): Iterator[This]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing maps of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       Iterator#sliding

125. #### def span(p: ((A, B)) ⇒ Boolean): (This, This)

     Splits this map into a prefix/suffix pair according to a predicate.

     Splits this map into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       the test predicate

     returns

       a pair consisting of the longest prefix of this map whose elements all satisfy `p`, and the rest of this map.

     Definition Classes
       TraversableLike → GenTraversableLike

126. #### def splitAt(n: Int): (This, This)

     Splits this map into two at a given position.

     Splits this map into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the position at which to split.

     returns

       a pair of maps consisting of the first `n` elements of this map, and the other elements.

     Definition Classes
       TraversableLike → GenTraversableLike

127. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this map. Unless overridden in subclasses, the string prefix of every map is `"Map"`.

     Definition Classes
       MapLike → TraversableLike → GenTraversableLike

128. #### abstract def sum: (A, B)

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this map with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

129. #### def sum[B >: (A, B)](implicit num: Numeric[B]): B

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     B

       the result type of the `+` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this map with respect to the `+` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

130. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

131. #### def tail: This

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a map consisting of all elements of this map except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the map is empty.

132. #### def tails: Iterator[This]

     Iterates over the tails of this map.

     Iterates over the tails of this map. The first value will be this map and the final one will be an empty map, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this map

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

133. #### def take(n: Int): This

     Selects first n elements.

     Selects first n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       Tt number of elements to take from this map.

     returns

       a map consisting only of the first `n` elements of this map, or else the whole map, if it has less than `n` elements.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

134. #### def takeRight(n: Int): This

     Selects last n elements.

     Selects last n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the number of elements to take

     returns

       a map consisting only of the last `n` elements of this map, or else the whole map, if it has less than `n` elements.

     Definition Classes
       IterableLike

135. #### def takeWhile(p: ((A, B)) ⇒ Boolean): This

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       The predicate used to test elements.

     returns

       the longest prefix of this map whose elements all satisfy the predicate `p`.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

136. #### def thisCollection: Iterable[(A, B)]

     The underlying collection seen as an instance of `Map`.

     The underlying collection seen as an instance of `Map`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IterableLike → TraversableLike

137. #### abstract def toArray: Array[(A, B)]

     [use case] Converts this map to an array.

     [use case]

     Converts this map to an array.

     returns

       an array containing all elements of this map.

     Definition Classes
       GenTraversableOnce

138. #### def toArray[B >: (A, B)](implicit arg0: ClassManifest[B]): Array[B]

     Converts this map to an array.

     Converts this map to an array.

     B

       the type of the elements of the array. A `ClassManifest` for this type must be available.

     returns

       an array containing all elements of this map.

     Definition Classes
       TraversableOnce → GenTraversableOnce

139. #### def toBuffer[C >: (A, B)]: Buffer[C]

     Converts this map to a mutable buffer.

     Converts this map to a mutable buffer.

     returns

       a buffer containing all elements of this map.

     Definition Classes
       MapLike → TraversableOnce → GenTraversableOnce

140. #### def toCollection(repr: This): Iterable[(A, B)]

     A conversion from collections of type `Repr` to `Map` objects.

     A conversion from collections of type `Repr` to `Map` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IterableLike → TraversableLike

141. #### def toIndexedSeq[B >: (A, B)]: IndexedSeq[B]

     Converts this map to an indexed sequence.

     Converts this map to an indexed sequence.

     returns

       an indexed sequence containing all elements of this map.

     Definition Classes
       TraversableOnce → GenTraversableOnce

142. #### def toIterable: Iterable[(A, B)]

     Converts this map to an iterable collection.

     Converts this map to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     returns

       an `Iterable` containing all elements of this map.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

143. #### def toIterator: Iterator[(A, B)]

     Returns an Iterator over the elements in this map.

     Returns an Iterator over the elements in this map. Will return the same Iterator if this instance is already an Iterator.

     returns

       an Iterator containing all elements of this map.

     Definition Classes
       TraversableLike → GenTraversableOnce

144. #### def toList: List[(A, B)]

     Converts this map to a list.

     Converts this map to a list.

     returns

       a list containing all elements of this map.

     Definition Classes
       TraversableOnce → GenTraversableOnce

145. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this map to a map.

     [use case]

     Converts this map to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this map.

     Definition Classes
       GenTraversableOnce

146. #### def toMap[T, U](implicit ev: <:<[(A, B), (T, U)]): Map[T, U]

     Converts this map to a map.

     Converts this map to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this map.

     Definition Classes
       TraversableOnce → GenTraversableOnce

147. #### def toSeq: Seq[(A, B)]

     Overridden for efficiency.

     Overridden for efficiency.

     returns

       a sequence containing all elements of this map.

     Definition Classes
       MapLike → TraversableOnce → GenTraversableOnce

148. #### def toSet[B >: (A, B)]: Set[B]

     Converts this map to a set.

     Converts this map to a set.

     returns

       a set containing all elements of this map.

     Definition Classes
       TraversableOnce → GenTraversableOnce

149. #### def toStream: Stream[(A, B)]

     Converts this map to a stream.

     Converts this map to a stream.

     returns

       a stream containing all elements of this map.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

150. #### def toString(): String

     Converts this map to a string.

     Converts this map to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this map, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       MapLike → TraversableLike → Function1 → AnyRef → Any

151. #### def toTraversable: Traversable[(A, B)]

     Converts this map to an unspecified Traversable.

     Converts this map to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     returns

       a Traversable containing all elements of this map.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

152. #### abstract def updated(key: A, value: B): Map[A, B]

     [use case] Creates a new map obtained by updating this map with a given key/value pair.

     [use case]

     Creates a new map obtained by updating this map with a given key/value pair.

     key

       the key

     value

       the value

     returns

       A new map with the new key/value mapping added to this map.

153. #### def updated[B1 >: B](key: A, value: B1): Map[A, B1]

     Creates a new map obtained by updating this map with a given key/value pair.

     Creates a new map obtained by updating this map with a given key/value pair.

     B1

       the type of the added value

     key

       the key

     value

       the value

     returns

       A new map with the new key/value mapping added to this map.

154. #### def values: Iterable[B]

     Collects all values of this map in an iterable collection.

     Collects all values of this map in an iterable collection.

     returns

       the values of this map as an iterable.

     Annotations
       @migration
     Migration

       (Changed in version 2.8.0) `values` returns `Iterable[B]` rather than `Iterator[B]`.

155. #### def valuesIterator: Iterator[B]

     Creates an iterator for all values in this map.

     Creates an iterator for all values in this map.

     returns

       an iterator over all values that are associated with some key in this map.

156. #### def view(from: Int, until: Int): IterableView[(A, B), This]

     Creates a non-strict view of a slice of this map.

     Creates a non-strict view of a slice of this map.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current map, whereas `slice` produces a new map.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this map, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       IterableLike → TraversableLike

157. #### def view: IterableView[(A, B), This]

     Creates a non-strict view of this map.

     Creates a non-strict view of this map.

     returns

       a non-strict view of this map.

     Definition Classes
       IterableLike → TraversableLike

158. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

159. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

160. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

161. #### def withFilter(p: ((A, B)) ⇒ Boolean): FilterMonadic[(A, B), This]

     Creates a non-strict filter of this map.

     Creates a non-strict filter of this map.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this map which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

162. #### abstract def zip[B](that: GenIterable[B]): Map[((A, B), B)]

     [use case] Returns a map formed from this map and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a map formed from this map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this map and `that`. The length of the returned collection is the minimum of the lengths of this map and `that`.

     Definition Classes
       GenIterableLike

163. #### def zip[A1 >: (A, B), B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[This, (A1, B), That]): That

     Returns a map formed from this map and another iterable collection by combining corresponding elements in pairs.

     Returns a map formed from this map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     B

       the type of the second half of the returned pairs

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this map and `that`. The length of the returned collection is the minimum of the lengths of this map and `that`.

     Definition Classes
       IterableLike → GenIterableLike

164. #### abstract def zipAll[B](that: Iterable[B], thisElem: (A, B), thatElem: B): Map[((A, B), B)]

     [use case] Returns a map formed from this map and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a map formed from this map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this map is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this map.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this map and `that`. The length of the returned collection is the maximum of the lengths of this map and `that`. If this map is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this map, `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

165. #### def zipAll[B, A1 >: (A, B), That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[This, (A1, B), That]): That

     Returns a map formed from this map and another iterable collection by combining corresponding elements in pairs.

     Returns a map formed from this map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this map is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this map.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this map and `that`. The length of the returned collection is the maximum of the lengths of this map and `that`. If this map is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this map, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike

166. #### abstract def zipWithIndex: Map[((A, B), Int)]

     [use case] Zips this map with its indices.

     [use case]

     Zips this map with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this map paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

167. #### def zipWithIndex[A1 >: (A, B), That](implicit bf: CanBuildFrom[This, (A1, Int), That]): That

     Zips this map with its indices.

     Zips this map with its indices.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this map paired with their index. Indices start at `0`.

     Definition Classes
       IterableLike → GenIterableLike

### Deprecated Value Members

1. #### def elements: Iterator[(A, B)]

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `iterator' instead`

2. #### def first: (A, B)

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `head' instead`

3. #### def firstOption: Option[(A, B)]

   `None` if iterable is empty.

   `None` if iterable is empty.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `headOption' instead`

4. #### def mapElements[C](f: (B) ⇒ C): Map[A, C]

   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `mapValues' instead`

5. #### def projection: IterableView[(A, B), This]

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `view' instead`

### Inherited from Subtractable[A, This]

### Inherited from GenMapLike[A, B, This]

### Inherited from IterableLike[(A, B), This]

### Inherited from GenIterableLike[(A, B), This]

### Inherited from TraversableLike[(A, B), This]

### Inherited from GenTraversableLike[(A, B), This]

### Inherited from Parallelizable[(A, B), ParMap[A, B]]

### Inherited from TraversableOnce[(A, B)]

### Inherited from GenTraversableOnce[(A, B)]

### Inherited from FilterMonadic[(A, B), This]

### Inherited from HasNewBuilder[(A, B), This]

### Inherited from Equals

### Inherited from PartialFunction[A, B]

### Inherited from (A) ⇒ B

### Inherited from AnyRef

### Inherited from Any